version: '3.1'
services:
  elasticsearch:
    image: docker.elastic.co/elasticsearch/elasticsearch:7.5.1
    container_name: es
    ports: 
        - '9200:9200'
        - '9300:9300'
    volumes:
        - ./elasticsearch/elasticsearch.yml:/usr/share/elasticsearch/config/elasticsearch.yml:ro
        - ./certs/:/usr/share/elasticsearch/config/certs
        - es-data:/usr/share/elasticsearch/data
    environment:
        - xpack.security.enabled=true
        - discovery.type=single-node
        - ELASTIC_PASSWORD=${ELK_PASSWORD}



  kibana:
    image: docker.elastic.co/kibana/kibana:7.5.1
    container_name: kibana
    ports: 
        - '443:5601'
    volumes:
        - ./kibana/kibana.yml:/usr/share/kibana/config/kibana.yml:ro
        - ./certs/:/usr/share/kibana/config/certs
    depends_on: 
        - 'elasticsearch'
    environment:
        - ELASTICSEARCH_HOST=${ELASTICSEARCH_HOST}
        - ELK_USERNAME=${ELK_USERNAME}
        - ELK_PASSWORD=${ELK_PASSWORD}

  logstash:
    image: docker.elastic.co/logstash/logstash:7.5.1
    container_name: logstash
    ports: 
        - '5044:5044'
    depends_on: 
        - 'elasticsearch'
    volumes:
        - ./logstash/:/config-dir
        - ./logstash/logstash.yml:/usr/share/logstash/config/logstash.yml
        - ./certs/:/usr/share/logstash/config/certs

    command: >
        bash -c "logstash -f /config-dir/logstash.conf"

    environment:
        - ELASTICSEARCH_HOST=${ELASTICSEARCH_HOST}
        - ELK_USERNAME=${ELK_USERNAME}
        - ELK_PASSWORD=${ELK_PASSWORD}

volumes:
    es-data:
        driver: local
